<template>
    <div class="container">
        <div class="col-sm-7">
            <FilterItem v-on:search-item="searchItem"/>
            <ul class="list-group">
                <Item v-bind:key="item.id" v-bind:item="item" v-for="item in filterResults"
                      v-on:update-status="updateStatus"
                      v-on:del-item="deleteItem"
                      v-on:get-item="getItem"/>
            </ul>
            <EditItem v-bind:currentItem="currentItem" v-on:update-item="updateItem"/>
            <AddItem v-on:add-item="addItem"/>
        </div>
    </div>
</template>

<script>
    import AddItem from '../components/items/AddItem'
    import Item from '../components/items/Item'
    import EditItem from '../components/items/EditItem'
    import FilterItem from '../components/items/FilterItem'

    export default {
        name: 'Items',
        components: {
            AddItem,
            Item,
            EditItem,
            FilterItem
        },
        data() {
            return {
                items: [],
                currentItem: null,
                filterResults: [],
            }
        },
        created() {
            this.fetchItems();
        },
        methods: {
            fetchItems() {
                let uri = 'http://localhost:8000/api/items';
                this.axios.get(uri)
                    .then(res => {
                        this.items = res.data;
                        this.filterResults = this.items;
                    })
                    .catch(err => console.log(err));
            },

            addItem(newItem) {
                let uri = 'http://localhost:8000/api/items';
                this.axios.post(uri, newItem)
                    .then(res => {
                        let addIdItem = Object.assign({}, {id: res.data.id}, newItem);
                        this.items = [...this.items, addIdItem];
                        this.filterResults = this.items;
                        console.log(res.data.message);
                    })
                    .catch(err => console.log(err));
            },

            updateStatus(item) {
                let uri = 'http://localhost:8000/api/items/'+item.id;
                this.axios.patch(uri, item).then((res) => {
                    console.log(res.data);
                }).catch(err => console.log(err));
            },

            updateItem(item) {
                let uri = 'http://localhost:8000/api/items/'+item.id;
                this.axios.patch(uri, item).then((res) => {
                    let foundIndex = this.items.findIndex(x => x.id == item.id);
                    this.items[foundIndex] = item;
                    this.items = [...this.items];
                    this.filterResults = this.items;
                    console.log(res.data);
                }).catch(err => console.log(err));
            },

            deleteItem(id) {
                let uri = 'http://localhost:8000/api/items/'+id;
                this.axios.delete(uri).then((res) => {
                    this.items = this.items.filter(item => item.id !== id);
                    this.filterResults = this.items;
                    console.log(res.data);
                }).catch(err => console.log(err));
            },

            getItem(id) {
                let uri = 'http://localhost:8000/api/items/'+id+'/edit';
                this.axios.get(uri).then((response) => {
                    this.currentItem = response.data;
                });
            },

            searchItem(title) {
                this.filterResults = this.items.filter(item => {
                    return item.title.toLowerCase().includes(title.toLowerCase());
                });
            }
        }
    }
</script>